7 echo >&2 "usage: $0 [--signoff] [--dotest=<dir>] [--utf8] [--binary] [--3way] <mbox>"
8 echo >&2 " or, when resuming"
9 echo >&2 " $0 [--skip | --resolved]"
14 echo "$1" >"$dotest/next"
19 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
20 "$dotest/patch" "$dotest/info"
21 echo "$next" >"$dotest/next"
26 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
28 rm -fr "$dotest"/patch-merge-*
29 mkdir "$dotest/patch-merge-tmp-dir"
31 # First see if the patch records the index info that we can use.
32 if git-apply -z --index-info "$dotest/patch" \
33 >"$dotest/patch-merge-index-info" 2>/dev/null &&
34 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
35 git-update-index -z --index-info <"$dotest/patch-merge-index-info" &&
36 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
37 git-write-tree >"$dotest/patch-merge-base+" &&
38 # index has the base tree now.
40 cd "$dotest/patch-merge-tmp-dir" &&
41 GIT_INDEX_FILE="../patch-merge-tmp-index" \
42 GIT_OBJECT_DIRECTORY="$O_OBJECT" \
43 git-apply $binary --index <../patch
46 echo Using index info to reconstruct a base tree...
47 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
48 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
50 # Otherwise, try nearby trees that can be used to apply the
55 # Hoping the patch is against our recent commits...
56 git-rev-list --max-count=$N HEAD
58 # or hoping the patch is against known tags...
59 git-ls-remote --tags .
63 # See if we have it as a tree...
64 git-cat-file tree "$base" >/dev/null 2>&1 || continue
66 rm -fr "$dotest"/patch-merge-* &&
67 mkdir "$dotest/patch-merge-tmp-dir" || break
69 cd "$dotest/patch-merge-tmp-dir" &&
70 GIT_INDEX_FILE=../patch-merge-tmp-index &&
71 GIT_OBJECT_DIRECTORY="$O_OBJECT" &&
72 export GIT_INDEX_FILE GIT_OBJECT_DIRECTORY &&
73 git-read-tree "$base" &&
74 git-apply $binary --index &&
75 mv ../patch-merge-tmp-index ../patch-merge-index &&
76 echo "$base" >../patch-merge-base
77 ) <"$dotest/patch" 2>/dev/null && break
81 test -f "$dotest/patch-merge-index" &&
82 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git-write-tree) &&
83 orig_tree=$(cat "$dotest/patch-merge-base") &&
84 rm -fr "$dotest"/patch-merge-* || exit 1
86 echo Falling back to patching base and 3-way merge...
88 # This is not so wrong. Depending on which base we picked,
89 # orig_tree may be wildly different from ours, but his_tree
90 # has the same set of wildly different changes in parts the
91 # patch did not touch, so resolve ends up cancelling them,
92 # saying that we reverted all those changes.
94 git-merge-resolve $orig_tree -- HEAD $his_tree || {
95 echo Failed to merge in the changes.
101 dotest=.dotest sign= utf8= keep= skip= interactive= resolved= binary=
103 while case "$#" in 0) break;; esac
106 -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
107 dotest=`expr "$1" : '-[^=]*=\(.*\)'`; shift ;;
108 -d|--d|--do|--dot|--dote|--dotes|--dotest)
109 case "$#" in 1) usage ;; esac; shift
112 -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
113 --interacti|--interactiv|--interactive)
114 interactive=t; shift ;;
116 -b|--b|--bi|--bin|--bina|--binar|--binary)
119 -3|--3|--3w|--3wa|--3way)
121 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
123 -u|--u|--ut|--utf|--utf8)
125 -k|--k|--ke|--kee|--keep)
128 -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
143 # If the dotest directory exists, but we have finished applying all the
144 # patches in them, clear it out.
145 if test -d "$dotest" &&
146 last=$(cat "$dotest/last") &&
147 next=$(cat "$dotest/next") &&
149 test "$next" -gt "$last"
156 test ",$#," = ",0," ||
157 die "previous dotest directory $dotest still exists but mbox given."
160 # Make sure we are not given --skip nor --resolved
161 test ",$skip,$resolved," = ,,, ||
162 die "we are not resuming."
165 mkdir -p "$dotest" || exit
167 # cat does the right thing for us, including '-' to mean
170 git-mailsplit -d$prec "$dotest/" >"$dotest/last" || {
175 # -b, -s, -u and -k flags are kept for the resuming session after
177 # -3 and -i can and must be given when resuming.
178 echo "$binary" >"$dotest/binary"
179 echo "$sign" >"$dotest/sign"
180 echo "$utf8" >"$dotest/utf8"
181 echo "$keep" >"$dotest/keep"
182 echo 1 >"$dotest/next"
187 files=$(git-diff-index --cached --name-only HEAD) || exit
188 if [ "$files" ]; then
189 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
194 if test "$(cat "$dotest/binary")" = t
196 binary=--allow-binary-replacement
198 if test "$(cat "$dotest/utf8")" = t
202 if test "$(cat "$dotest/keep")" = t
206 if test "$(cat "$dotest/sign")" = t
208 SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
210 s/^/Signed-off-by: /'
216 last=`cat "$dotest/last"`
217 this=`cat "$dotest/next"`
220 this=`expr "$this" + 1`
223 if test "$this" -gt "$last"
230 while test "$this" -le "$last"
232 msgnum=`printf "%0${prec}d" $this`
233 next=`expr "$this" + 1`
234 test -f "$dotest/$msgnum" || {
239 # If we are not resuming, parse and extract the patch information
240 # into separate files:
241 # - info records the authorship and title
242 # - msg is the rest of commit log message
243 # - patch is the patch body.
245 # When we are resuming, these files are either already prepared
246 # by the user, or the user can tell us to do so by --resolved flag.
249 git-mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
250 <"$dotest/$msgnum" >"$dotest/info" ||
252 git-stripspace < "$dotest/msg" > "$dotest/msg-clean"
256 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
257 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
258 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
259 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
261 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
262 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
266 if test '' != "$SIGNOFF"
269 sed -ne '/^Signed-off-by: /p' \
270 "$dotest/msg-clean" |
274 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
275 test '' = "$LAST_SIGNED_OFF_BY" && echo
283 if test -s "$dotest/msg-clean"
286 cat "$dotest/msg-clean"
288 if test '' != "$ADD_SIGNOFF"
292 } >"$dotest/final-commit"
295 case "$resolved,$interactive" in
297 # This is used only for interactive view option.
298 git-diff-index -p --cached HEAD >"$dotest/patch"
304 if test "$interactive" = t
307 die "cannot be interactive without stdin connected to a terminal."
309 while test "$action" = again
311 echo "Commit Body is:"
312 echo "--------------------------"
313 cat "$dotest/final-commit"
314 echo "--------------------------"
315 echo -n "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
319 [aA]*) action=yes interactive= ;;
320 [nN]*) action=skip ;;
321 [eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
324 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
332 if test $action = skip
338 if test -x "$GIT_DIR"/hooks/applypatch-msg
340 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
345 echo "Applying '$SUBJECT'"
350 git-apply $binary --index "$dotest/patch"
354 # Resolved means the user did all the hard work, and
355 # we do not have to do any patch application. Just
356 # trust what the user has in the index file and the
363 if test $apply_status = 1 && test "$threeway" = t
367 # Applying the patch to an earlier tree and merging the
368 # result may have produced the same tree as ours.
369 changed="$(git-diff-index --cached --name-only -z HEAD)"
370 if test '' = "$changed"
372 echo No changes -- Patch already applied.
376 # clear apply_status -- we have successfully merged.
380 if test $apply_status != 0
382 echo Patch failed at $msgnum.
386 if test -x "$GIT_DIR"/hooks/pre-applypatch
388 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
391 tree=$(git-write-tree) &&
392 echo Wrote tree $tree &&
393 parent=$(git-rev-parse --verify HEAD) &&
394 commit=$(git-commit-tree $tree -p $parent <"$dotest/final-commit") &&
395 echo Committed: $commit &&
396 git-update-ref HEAD $commit $parent ||
399 if test -x "$GIT_DIR"/hooks/post-applypatch
401 "$GIT_DIR"/hooks/post-applypatch